/**
 * Copyright © 2016 Magento. All rights reserved.
 * See COPYING.txt for license details.
 */
/*browser:true*/
/*global define*/
define(
    [
        'jquery',
        'Magento_Checkout/js/view/payment/default'
    ],
    function ($, Component) {
        'use strict';

        return Component.extend({
            redirectAfterPlaceOrder: false,

            defaults: {
                template: 'ShineSoftware_Setefi/payment/form',
            },

            /**
             * After place order callback
             */
            afterPlaceOrder: function () {
                // throw new Error("DEBUG - redirect the user to: " + window.checkoutConfig.payment.setefi.redirectUrl);

                // redirection to the controller .../setefi/hosted/redirect/
                $.mage.redirect(window.checkoutConfig.payment.setefi.redirectUrl);
            },


            /** Open window with  */
            showAcceptanceWindow: function(data, event) {
                window.open(
                    $(event.currentTarget).attr('href'),
                    'olcwhatissetefi',
                    'toolbar=no, location=no,' +
                    ' directories=no, status=no,' +
                    ' menubar=no, scrollbars=yes,' +
                    ' resizable=yes, ,left=0,' +
                    ' top=0, width=400, height=350'
                );
                return false;
            },

            /** Returns payment acceptance mark link path */
            getPaymentAcceptanceMarkHref: function() {
                return window.checkoutConfig.payment.setefi.paymentAcceptanceMarkHref;
            },

            /** Returns payment acceptance mark image path */
            getPaymentAcceptanceMarkSrc: function() {
                return window.checkoutConfig.payment.setefi.paymentAcceptanceMarkSrc;
            },

            /** Returns payment bank link */
            getBankLink: function() {
                return window.checkoutConfig.payment.setefi.bankLink;
            },


        });
    }
);